/* gitg-textconv.c generated by valac 0.56.18, the Vala compiler
 * generated from gitg-textconv.vala, do not modify */

/*
 *
 * Copyright (C) 2021 - Alberto Fanjul
 *
 * gitg is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * gitg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gitg. If not, see <http://www.gnu.org/licenses/>.
 */

#include "libgitg.h"
#include <libgit2-glib/ggit.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <stdio.h>
#include <glib-object.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_GgitOId_free0(var) ((var == NULL) ? NULL : (var = (_vala_GgitOId_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _GitgParamSpecTextConv GitgParamSpecTextConv;

struct _GitgParamSpecTextConv {
	GParamSpec parent_instance;
};

static gpointer gitg_text_conv_parent_class = NULL;

static gchar* gitg_text_conv_get_textconv_command (GitgRepository* repository,
                                            GgitDiffFile* file);
static guint8* _vala_array_dup26 (guint8* self,
                           gssize length);
static GgitOId* _vala_GgitOId_copy (GgitOId* self);
static guint8* _vala_array_dup27 (guint8* self,
                           gssize length);
static void _vala_GgitOId_free (GgitOId* self);
static guint8* _vala_array_dup28 (guint8* self,
                           gssize length);
static guint8* gitg_text_conv_textconv (const gchar* command,
                                 guint8* data,
                                 gint data_length1,
                                 gint* result_length1);
static void _vala_array_add18 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static guint8* _vala_array_dup29 (guint8* self,
                           gssize length);
static void _g_free_gdestroy_notify (void* data);
static guint8* _vala_array_dup30 (guint8* self,
                           gssize length);
static void gitg_text_conv_finalize (GitgTextConv * obj);
static GType gitg_text_conv_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

gboolean
gitg_text_conv_has_textconv_command (GitgRepository* repository,
                                     GgitDiffFile* file)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 26 "../libgitg/gitg-textconv.vala"
	g_return_val_if_fail (repository != NULL, FALSE);
#line 26 "../libgitg/gitg-textconv.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 28 "../libgitg/gitg-textconv.vala"
	_tmp0_ = gitg_text_conv_get_textconv_command (repository, file);
#line 28 "../libgitg/gitg-textconv.vala"
	_tmp1_ = _tmp0_;
#line 28 "../libgitg/gitg-textconv.vala"
	_tmp2_ = _tmp1_ != NULL;
#line 28 "../libgitg/gitg-textconv.vala"
	_g_free0 (_tmp1_);
#line 28 "../libgitg/gitg-textconv.vala"
	result = _tmp2_;
#line 28 "../libgitg/gitg-textconv.vala"
	return result;
#line 112 "gitg-textconv.c"
}

static gchar*
gitg_text_conv_get_textconv_command (GitgRepository* repository,
                                     GgitDiffFile* file)
{
	gchar* command = NULL;
	gchar* path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* diffattr = NULL;
	const gchar* _tmp6_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 31 "../libgitg/gitg-textconv.vala"
	g_return_val_if_fail (repository != NULL, NULL);
#line 31 "../libgitg/gitg-textconv.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 33 "../libgitg/gitg-textconv.vala"
	command = NULL;
#line 34 "../libgitg/gitg-textconv.vala"
	_tmp0_ = ggit_diff_file_get_path (file);
#line 34 "../libgitg/gitg-textconv.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 34 "../libgitg/gitg-textconv.vala"
	path = _tmp1_;
#line 35 "../libgitg/gitg-textconv.vala"
	diffattr = NULL;
#line 141 "gitg-textconv.c"
	{
		const gchar* _tmp2_ = NULL;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 38 "../libgitg/gitg-textconv.vala"
		_tmp3_ = path;
#line 38 "../libgitg/gitg-textconv.vala"
		_tmp4_ = ggit_repository_get_attribute ((GgitRepository*) repository, _tmp3_, "diff", GGIT_ATTRIBUTE_CHECK_FILE_THEN_INDEX, &_inner_error0_);
#line 38 "../libgitg/gitg-textconv.vala"
		_tmp2_ = _tmp4_;
#line 38 "../libgitg/gitg-textconv.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 155 "gitg-textconv.c"
			goto __catch0_g_error;
		}
#line 38 "../libgitg/gitg-textconv.vala"
		_tmp5_ = g_strdup (_tmp2_);
#line 38 "../libgitg/gitg-textconv.vala"
		_g_free0 (diffattr);
#line 38 "../libgitg/gitg-textconv.vala"
		diffattr = _tmp5_;
#line 164 "gitg-textconv.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 36 "../libgitg/gitg-textconv.vala"
		g_clear_error (&_inner_error0_);
#line 171 "gitg-textconv.c"
	}
	__finally0:
#line 36 "../libgitg/gitg-textconv.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 36 "../libgitg/gitg-textconv.vala"
		_g_free0 (diffattr);
#line 36 "../libgitg/gitg-textconv.vala"
		_g_free0 (path);
#line 36 "../libgitg/gitg-textconv.vala"
		_g_free0 (command);
#line 36 "../libgitg/gitg-textconv.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 36 "../libgitg/gitg-textconv.vala"
		g_clear_error (&_inner_error0_);
#line 36 "../libgitg/gitg-textconv.vala"
		return NULL;
#line 188 "gitg-textconv.c"
	}
#line 40 "../libgitg/gitg-textconv.vala"
	_tmp6_ = diffattr;
#line 40 "../libgitg/gitg-textconv.vala"
	if (_tmp6_ != NULL) {
#line 194 "gitg-textconv.c"
		gchar* textconv_key = NULL;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 42 "../libgitg/gitg-textconv.vala"
		_tmp7_ = diffattr;
#line 42 "../libgitg/gitg-textconv.vala"
		_tmp8_ = g_strdup_printf ("diff.%s.textconv", _tmp7_);
#line 42 "../libgitg/gitg-textconv.vala"
		textconv_key = _tmp8_;
#line 204 "gitg-textconv.c"
		{
			GgitConfig* _tmp9_ = NULL;
			GgitConfig* _tmp10_;
			GgitConfig* config = NULL;
			GgitConfig* _tmp11_;
			const gchar* _tmp12_ = NULL;
			GgitConfig* _tmp13_;
			const gchar* _tmp14_;
			const gchar* _tmp15_;
			gchar* _tmp16_;
#line 45 "../libgitg/gitg-textconv.vala"
			_tmp10_ = ggit_repository_get_config ((GgitRepository*) repository, &_inner_error0_);
#line 45 "../libgitg/gitg-textconv.vala"
			_tmp9_ = _tmp10_;
#line 45 "../libgitg/gitg-textconv.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 221 "gitg-textconv.c"
				goto __catch1_g_error;
			}
#line 45 "../libgitg/gitg-textconv.vala"
			_tmp11_ = ggit_config_snapshot (_tmp9_, &_inner_error0_);
#line 45 "../libgitg/gitg-textconv.vala"
			config = _tmp11_;
#line 45 "../libgitg/gitg-textconv.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 45 "../libgitg/gitg-textconv.vala"
				_g_object_unref0 (_tmp9_);
#line 232 "gitg-textconv.c"
				goto __catch1_g_error;
			}
#line 46 "../libgitg/gitg-textconv.vala"
			_tmp13_ = config;
#line 46 "../libgitg/gitg-textconv.vala"
			_tmp14_ = textconv_key;
#line 46 "../libgitg/gitg-textconv.vala"
			_tmp15_ = ggit_config_get_string (_tmp13_, _tmp14_, &_inner_error0_);
#line 46 "../libgitg/gitg-textconv.vala"
			_tmp12_ = _tmp15_;
#line 46 "../libgitg/gitg-textconv.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 46 "../libgitg/gitg-textconv.vala"
				_g_object_unref0 (config);
#line 46 "../libgitg/gitg-textconv.vala"
				_g_object_unref0 (_tmp9_);
#line 249 "gitg-textconv.c"
				goto __catch1_g_error;
			}
#line 46 "../libgitg/gitg-textconv.vala"
			_tmp16_ = g_strdup (_tmp12_);
#line 46 "../libgitg/gitg-textconv.vala"
			_g_free0 (command);
#line 46 "../libgitg/gitg-textconv.vala"
			command = _tmp16_;
#line 43 "../libgitg/gitg-textconv.vala"
			_g_object_unref0 (config);
#line 43 "../libgitg/gitg-textconv.vala"
			_g_object_unref0 (_tmp9_);
#line 262 "gitg-textconv.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GError* _tmp17_;
			const gchar* _tmp18_;
#line 43 "../libgitg/gitg-textconv.vala"
			e = _inner_error0_;
#line 43 "../libgitg/gitg-textconv.vala"
			_inner_error0_ = NULL;
#line 50 "../libgitg/gitg-textconv.vala"
			_tmp17_ = e;
#line 50 "../libgitg/gitg-textconv.vala"
			_tmp18_ = _tmp17_->message;
#line 50 "../libgitg/gitg-textconv.vala"
			g_warning ("gitg-textconv.vala:50: error getting textconv command: %s\n", _tmp18_);
#line 43 "../libgitg/gitg-textconv.vala"
			_g_error_free0 (e);
#line 282 "gitg-textconv.c"
		}
		__finally1:
#line 43 "../libgitg/gitg-textconv.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 43 "../libgitg/gitg-textconv.vala"
			_g_free0 (textconv_key);
#line 43 "../libgitg/gitg-textconv.vala"
			_g_free0 (diffattr);
#line 43 "../libgitg/gitg-textconv.vala"
			_g_free0 (path);
#line 43 "../libgitg/gitg-textconv.vala"
			_g_free0 (command);
#line 43 "../libgitg/gitg-textconv.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 43 "../libgitg/gitg-textconv.vala"
			g_clear_error (&_inner_error0_);
#line 43 "../libgitg/gitg-textconv.vala"
			return NULL;
#line 301 "gitg-textconv.c"
		}
#line 40 "../libgitg/gitg-textconv.vala"
		_g_free0 (textconv_key);
#line 305 "gitg-textconv.c"
	}
#line 53 "../libgitg/gitg-textconv.vala"
	result = command;
#line 53 "../libgitg/gitg-textconv.vala"
	_g_free0 (diffattr);
#line 53 "../libgitg/gitg-textconv.vala"
	_g_free0 (path);
#line 53 "../libgitg/gitg-textconv.vala"
	return result;
#line 315 "gitg-textconv.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 352 "gitg-textconv.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 358 "gitg-textconv.c"
}

static guint8*
_vala_array_dup26 (guint8* self,
                   gssize length)
{
#line 58 "../libgitg/gitg-textconv.vala"
	if (length > 0) {
#line 58 "../libgitg/gitg-textconv.vala"
		return g_memdup2 (self, length * sizeof (guint8));
#line 369 "gitg-textconv.c"
	}
#line 58 "../libgitg/gitg-textconv.vala"
	return NULL;
#line 373 "gitg-textconv.c"
}

static GgitOId*
_vala_GgitOId_copy (GgitOId* self)
{
#line 61 "../libgitg/gitg-textconv.vala"
	return g_boxed_copy (ggit_oid_get_type (), self);
#line 381 "gitg-textconv.c"
}

static gpointer
__vala_GgitOId_copy0 (gpointer self)
{
#line 61 "../libgitg/gitg-textconv.vala"
	return self ? _vala_GgitOId_copy (self) : NULL;
#line 389 "gitg-textconv.c"
}

static guint8*
_vala_array_dup27 (guint8* self,
                   gssize length)
{
#line 66 "../libgitg/gitg-textconv.vala"
	if (length > 0) {
#line 66 "../libgitg/gitg-textconv.vala"
		return g_memdup2 (self, length * sizeof (guint8));
#line 400 "gitg-textconv.c"
	}
#line 66 "../libgitg/gitg-textconv.vala"
	return NULL;
#line 404 "gitg-textconv.c"
}

static void
_vala_GgitOId_free (GgitOId* self)
{
#line 63 "../libgitg/gitg-textconv.vala"
	g_boxed_free (ggit_oid_get_type (), self);
#line 412 "gitg-textconv.c"
}

guint8*
gitg_text_conv_get_textconv_content (GitgRepository* repository,
                                     GgitDiffFile* file,
                                     gint* result_length1)
{
	guint8* content = NULL;
	guint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_ = 0;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint8* _tmp3_;
	gint _tmp3__length1;
	gint content_length1;
	gint _content_size_;
	guint8* _tmp16_;
	gint _tmp16__length1;
	GError* _inner_error0_ = NULL;
	guint8* result;
#line 56 "../libgitg/gitg-textconv.vala"
	g_return_val_if_fail (repository != NULL, NULL);
#line 56 "../libgitg/gitg-textconv.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 58 "../libgitg/gitg-textconv.vala"
	_tmp0_ = string_get_data ("", &_tmp1_);
#line 58 "../libgitg/gitg-textconv.vala"
	_tmp0__length1 = _tmp1_;
#line 58 "../libgitg/gitg-textconv.vala"
	_tmp2_ = _tmp0_;
#line 58 "../libgitg/gitg-textconv.vala"
	_tmp2__length1 = _tmp0__length1;
#line 58 "../libgitg/gitg-textconv.vala"
	_tmp3_ = (_tmp2_ != NULL) ? _vala_array_dup26 (_tmp2_, _tmp2__length1) : _tmp2_;
#line 58 "../libgitg/gitg-textconv.vala"
	_tmp3__length1 = _tmp2__length1;
#line 58 "../libgitg/gitg-textconv.vala"
	content = _tmp3_;
#line 58 "../libgitg/gitg-textconv.vala"
	content_length1 = _tmp3__length1;
#line 58 "../libgitg/gitg-textconv.vala"
	_content_size_ = content_length1;
#line 59 "../libgitg/gitg-textconv.vala"
	if (file != NULL) {
#line 458 "gitg-textconv.c"
		GgitOId* oid = NULL;
		GgitOId* _tmp4_;
		GgitOId* _tmp5_;
		GgitOId* _tmp6_;
#line 61 "../libgitg/gitg-textconv.vala"
		_tmp4_ = ggit_diff_file_get_oid (file);
#line 61 "../libgitg/gitg-textconv.vala"
		_tmp5_ = __vala_GgitOId_copy0 (_tmp4_);
#line 61 "../libgitg/gitg-textconv.vala"
		oid = _tmp5_;
#line 62 "../libgitg/gitg-textconv.vala"
		_tmp6_ = oid;
#line 62 "../libgitg/gitg-textconv.vala"
		if (!ggit_oid_is_zero (_tmp6_)) {
#line 473 "gitg-textconv.c"
			{
				GgitBlob* blob = NULL;
				GgitOId* _tmp7_;
				gpointer _tmp8_;
				guint8* raw_content = NULL;
				GgitBlob* _tmp9_;
				gsize _tmp10_ = 0;
				guint8* _tmp11_;
				guint8* _tmp12_;
				gint _tmp12__length1;
				gint raw_content_length1;
				gint _raw_content_size_;
				guint8* _tmp13_;
				gint _tmp13__length1;
				gint _tmp14_ = 0;
				guint8* _tmp15_;
#line 65 "../libgitg/gitg-textconv.vala"
				_tmp7_ = oid;
#line 65 "../libgitg/gitg-textconv.vala"
				_tmp8_ = gitg_repository_lookup (repository, ggit_blob_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp7_, &_inner_error0_);
#line 65 "../libgitg/gitg-textconv.vala"
				blob = (GgitBlob*) _tmp8_;
#line 65 "../libgitg/gitg-textconv.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 498 "gitg-textconv.c"
					goto __catch0_g_error;
				}
#line 66 "../libgitg/gitg-textconv.vala"
				_tmp9_ = blob;
#line 66 "../libgitg/gitg-textconv.vala"
				_tmp11_ = ggit_blob_get_raw_content (_tmp9_, &_tmp10_);
#line 66 "../libgitg/gitg-textconv.vala"
				_tmp12_ = (_tmp11_ != NULL) ? _vala_array_dup27 (_tmp11_, _tmp10_) : _tmp11_;
#line 66 "../libgitg/gitg-textconv.vala"
				_tmp12__length1 = _tmp10_;
#line 66 "../libgitg/gitg-textconv.vala"
				raw_content = _tmp12_;
#line 66 "../libgitg/gitg-textconv.vala"
				raw_content_length1 = _tmp12__length1;
#line 66 "../libgitg/gitg-textconv.vala"
				_raw_content_size_ = raw_content_length1;
#line 67 "../libgitg/gitg-textconv.vala"
				_tmp13_ = raw_content;
#line 67 "../libgitg/gitg-textconv.vala"
				_tmp13__length1 = raw_content_length1;
#line 67 "../libgitg/gitg-textconv.vala"
				_tmp15_ = gitg_text_conv_get_textconv_content_from_raw (repository, file, _tmp13_, (gint) _tmp13__length1, &_tmp14_);
#line 67 "../libgitg/gitg-textconv.vala"
				content = (g_free (content), NULL);
#line 67 "../libgitg/gitg-textconv.vala"
				content = _tmp15_;
#line 67 "../libgitg/gitg-textconv.vala"
				content_length1 = _tmp14_;
#line 67 "../libgitg/gitg-textconv.vala"
				_content_size_ = content_length1;
#line 63 "../libgitg/gitg-textconv.vala"
				raw_content = (g_free (raw_content), NULL);
#line 63 "../libgitg/gitg-textconv.vala"
				_g_object_unref0 (blob);
#line 533 "gitg-textconv.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
#line 63 "../libgitg/gitg-textconv.vala"
				g_clear_error (&_inner_error0_);
#line 540 "gitg-textconv.c"
			}
			__finally0:
#line 63 "../libgitg/gitg-textconv.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 63 "../libgitg/gitg-textconv.vala"
				__vala_GgitOId_free0 (oid);
#line 63 "../libgitg/gitg-textconv.vala"
				content = (g_free (content), NULL);
#line 63 "../libgitg/gitg-textconv.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 63 "../libgitg/gitg-textconv.vala"
				g_clear_error (&_inner_error0_);
#line 63 "../libgitg/gitg-textconv.vala"
				return NULL;
#line 555 "gitg-textconv.c"
			}
		}
#line 59 "../libgitg/gitg-textconv.vala"
		__vala_GgitOId_free0 (oid);
#line 560 "gitg-textconv.c"
	}
#line 71 "../libgitg/gitg-textconv.vala"
	_tmp16_ = content;
#line 71 "../libgitg/gitg-textconv.vala"
	_tmp16__length1 = content_length1;
#line 71 "../libgitg/gitg-textconv.vala"
	if (result_length1) {
#line 71 "../libgitg/gitg-textconv.vala"
		*result_length1 = _tmp16__length1;
#line 570 "gitg-textconv.c"
	}
#line 71 "../libgitg/gitg-textconv.vala"
	result = _tmp16_;
#line 71 "../libgitg/gitg-textconv.vala"
	return result;
#line 576 "gitg-textconv.c"
}

static guint8*
_vala_array_dup28 (guint8* self,
                   gssize length)
{
#line 76 "../libgitg/gitg-textconv.vala"
	if (length > 0) {
#line 76 "../libgitg/gitg-textconv.vala"
		return g_memdup2 (self, length * sizeof (guint8));
#line 587 "gitg-textconv.c"
	}
#line 76 "../libgitg/gitg-textconv.vala"
	return NULL;
#line 591 "gitg-textconv.c"
}

guint8*
gitg_text_conv_get_textconv_content_from_raw (GitgRepository* repository,
                                              GgitDiffFile* file,
                                              guint8* raw_content,
                                              gint raw_content_length1,
                                              gint* result_length1)
{
	guint8* content = NULL;
	guint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_ = 0;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint8* _tmp3_;
	gint _tmp3__length1;
	gint content_length1;
	gint _content_size_;
	guint8* _tmp9_;
	gint _tmp9__length1;
	guint8* result;
#line 74 "../libgitg/gitg-textconv.vala"
	g_return_val_if_fail (repository != NULL, NULL);
#line 74 "../libgitg/gitg-textconv.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 76 "../libgitg/gitg-textconv.vala"
	_tmp0_ = string_get_data ("", &_tmp1_);
#line 76 "../libgitg/gitg-textconv.vala"
	_tmp0__length1 = _tmp1_;
#line 76 "../libgitg/gitg-textconv.vala"
	_tmp2_ = _tmp0_;
#line 76 "../libgitg/gitg-textconv.vala"
	_tmp2__length1 = _tmp0__length1;
#line 76 "../libgitg/gitg-textconv.vala"
	_tmp3_ = (_tmp2_ != NULL) ? _vala_array_dup28 (_tmp2_, _tmp2__length1) : _tmp2_;
#line 76 "../libgitg/gitg-textconv.vala"
	_tmp3__length1 = _tmp2__length1;
#line 76 "../libgitg/gitg-textconv.vala"
	content = _tmp3_;
#line 76 "../libgitg/gitg-textconv.vala"
	content_length1 = _tmp3__length1;
#line 76 "../libgitg/gitg-textconv.vala"
	_content_size_ = content_length1;
#line 77 "../libgitg/gitg-textconv.vala"
	if (raw_content != NULL) {
#line 638 "gitg-textconv.c"
		gchar* command = NULL;
		gchar* _tmp4_;
		const gchar* _tmp5_;
#line 79 "../libgitg/gitg-textconv.vala"
		_tmp4_ = gitg_text_conv_get_textconv_command (repository, file);
#line 79 "../libgitg/gitg-textconv.vala"
		command = _tmp4_;
#line 80 "../libgitg/gitg-textconv.vala"
		_tmp5_ = command;
#line 80 "../libgitg/gitg-textconv.vala"
		if (_tmp5_ != NULL) {
#line 650 "gitg-textconv.c"
			const gchar* _tmp6_;
			gint _tmp7_ = 0;
			guint8* _tmp8_;
#line 82 "../libgitg/gitg-textconv.vala"
			_tmp6_ = command;
#line 82 "../libgitg/gitg-textconv.vala"
			_tmp8_ = gitg_text_conv_textconv (_tmp6_, raw_content, (gint) raw_content_length1, &_tmp7_);
#line 82 "../libgitg/gitg-textconv.vala"
			content = (g_free (content), NULL);
#line 82 "../libgitg/gitg-textconv.vala"
			content = _tmp8_;
#line 82 "../libgitg/gitg-textconv.vala"
			content_length1 = _tmp7_;
#line 82 "../libgitg/gitg-textconv.vala"
			_content_size_ = content_length1;
#line 666 "gitg-textconv.c"
		}
#line 77 "../libgitg/gitg-textconv.vala"
		_g_free0 (command);
#line 670 "gitg-textconv.c"
	}
#line 85 "../libgitg/gitg-textconv.vala"
	_tmp9_ = content;
#line 85 "../libgitg/gitg-textconv.vala"
	_tmp9__length1 = content_length1;
#line 85 "../libgitg/gitg-textconv.vala"
	if (result_length1) {
#line 85 "../libgitg/gitg-textconv.vala"
		*result_length1 = _tmp9__length1;
#line 680 "gitg-textconv.c"
	}
#line 85 "../libgitg/gitg-textconv.vala"
	result = _tmp9_;
#line 85 "../libgitg/gitg-textconv.vala"
	return result;
#line 686 "gitg-textconv.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 708 "gitg-textconv.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 712 "gitg-textconv.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 718 "gitg-textconv.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 722 "gitg-textconv.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 726 "gitg-textconv.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 734 "gitg-textconv.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 762 "gitg-textconv.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 771 "gitg-textconv.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 785 "gitg-textconv.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 794 "gitg-textconv.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 808 "gitg-textconv.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 817 "gitg-textconv.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 826 "gitg-textconv.c"
}

static void
_vala_array_add18 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 97 "../libgitg/gitg-textconv.vala"
	if ((*length) == (*size)) {
#line 97 "../libgitg/gitg-textconv.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 97 "../libgitg/gitg-textconv.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 841 "gitg-textconv.c"
	}
#line 97 "../libgitg/gitg-textconv.vala"
	(*array)[(*length)++] = value;
#line 97 "../libgitg/gitg-textconv.vala"
	(*array)[*length] = NULL;
#line 847 "gitg-textconv.c"
}

static guint8*
_vala_array_dup29 (guint8* self,
                   gssize length)
{
#line 101 "../libgitg/gitg-textconv.vala"
	if (length > 0) {
#line 101 "../libgitg/gitg-textconv.vala"
		return g_memdup2 (self, length * sizeof (guint8));
#line 858 "gitg-textconv.c"
	}
#line 101 "../libgitg/gitg-textconv.vala"
	return NULL;
#line 862 "gitg-textconv.c"
}

static void
_g_free_gdestroy_notify (void* data)
{
#line 101 "../libgitg/gitg-textconv.vala"
	g_free (data);
#line 870 "gitg-textconv.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 104 "../libgitg/gitg-textconv.vala"
	return self ? g_object_ref (self) : NULL;
#line 878 "gitg-textconv.c"
}

static guint8*
_vala_array_dup30 (guint8* self,
                   gssize length)
{
#line 126 "../libgitg/gitg-textconv.vala"
	if (length > 0) {
#line 126 "../libgitg/gitg-textconv.vala"
		return g_memdup2 (self, length * sizeof (guint8));
#line 889 "gitg-textconv.c"
	}
#line 126 "../libgitg/gitg-textconv.vala"
	return NULL;
#line 893 "gitg-textconv.c"
}

static guint8*
gitg_text_conv_textconv (const gchar* command,
                         guint8* data,
                         gint data_length1,
                         gint* result_length1)
{
	gchar* lines = NULL;
	gchar* _tmp0_;
	const gchar* _tmp52_;
	guint8* _tmp53_;
	gint _tmp53__length1;
	gint _tmp54_ = 0;
	guint8* _tmp55_;
	gint _tmp55__length1;
	guint8* _tmp56_;
	gint _tmp56__length1;
	guint8* _tmp57_;
	gint _tmp57__length1;
	GError* _inner_error0_ = NULL;
	guint8* result;
#line 88 "../libgitg/gitg-textconv.vala"
	g_return_val_if_fail (command != NULL, NULL);
#line 90 "../libgitg/gitg-textconv.vala"
	_tmp0_ = g_strdup ("");
#line 90 "../libgitg/gitg-textconv.vala"
	lines = _tmp0_;
#line 922 "gitg-textconv.c"
	{
		gchar** command_array = NULL;
		gchar** _tmp1_;
		gchar** _tmp2_;
		gint command_array_length1;
		gint _command_array_size_;
		gchar* _tmp10_;
		GSubprocess* subproc = NULL;
		gchar** _tmp11_;
		gint _tmp11__length1;
		GSubprocess* _tmp12_;
		GMemoryInputStream* input = NULL;
		guint8* _tmp13_;
		gint _tmp13__length1;
		GMemoryInputStream* _tmp14_;
		GSubprocess* _tmp15_;
		GOutputStream* _tmp16_;
		GMemoryInputStream* _tmp17_;
		GInputStream* end_pipe = NULL;
		GSubprocess* _tmp18_;
		GInputStream* _tmp19_;
		GInputStream* _tmp20_;
		GDataInputStream* output = NULL;
		GInputStream* _tmp21_;
		GDataInputStream* _tmp22_;
		gchar* line = NULL;
		GInputStream* err_pipe = NULL;
		GSubprocess* _tmp35_;
		GInputStream* _tmp36_;
		GInputStream* _tmp37_;
		GDataInputStream* err = NULL;
		GInputStream* _tmp38_;
		GDataInputStream* _tmp39_;
		gchar* lineerr = NULL;
#line 93 "../libgitg/gitg-textconv.vala"
		_tmp2_ = _tmp1_ = g_strsplit (command, " ", 0);
#line 93 "../libgitg/gitg-textconv.vala"
		command_array = _tmp2_;
#line 93 "../libgitg/gitg-textconv.vala"
		command_array_length1 = _vala_array_length (_tmp1_);
#line 93 "../libgitg/gitg-textconv.vala"
		_command_array_size_ = command_array_length1;
#line 965 "gitg-textconv.c"
		{
			gint i = 0;
#line 94 "../libgitg/gitg-textconv.vala"
			i = 0;
#line 970 "gitg-textconv.c"
			{
				gboolean _tmp3_ = FALSE;
#line 94 "../libgitg/gitg-textconv.vala"
				_tmp3_ = TRUE;
#line 94 "../libgitg/gitg-textconv.vala"
				while (TRUE) {
#line 977 "gitg-textconv.c"
					gchar** _tmp5_;
					gint _tmp5__length1;
					gchar** _tmp6_;
					gint _tmp6__length1;
					gchar** _tmp7_;
					gint _tmp7__length1;
					const gchar* _tmp8_;
					gchar* _tmp9_;
#line 94 "../libgitg/gitg-textconv.vala"
					if (!_tmp3_) {
#line 988 "gitg-textconv.c"
						gint _tmp4_;
#line 94 "../libgitg/gitg-textconv.vala"
						_tmp4_ = i;
#line 94 "../libgitg/gitg-textconv.vala"
						i = _tmp4_ + 1;
#line 994 "gitg-textconv.c"
					}
#line 94 "../libgitg/gitg-textconv.vala"
					_tmp3_ = FALSE;
#line 94 "../libgitg/gitg-textconv.vala"
					_tmp5_ = command_array;
#line 94 "../libgitg/gitg-textconv.vala"
					_tmp5__length1 = command_array_length1;
#line 94 "../libgitg/gitg-textconv.vala"
					if (!(i < _tmp5__length1)) {
#line 94 "../libgitg/gitg-textconv.vala"
						break;
#line 1006 "gitg-textconv.c"
					}
#line 95 "../libgitg/gitg-textconv.vala"
					_tmp6_ = command_array;
#line 95 "../libgitg/gitg-textconv.vala"
					_tmp6__length1 = command_array_length1;
#line 95 "../libgitg/gitg-textconv.vala"
					_tmp7_ = command_array;
#line 95 "../libgitg/gitg-textconv.vala"
					_tmp7__length1 = command_array_length1;
#line 95 "../libgitg/gitg-textconv.vala"
					_tmp8_ = _tmp7_[i];
#line 95 "../libgitg/gitg-textconv.vala"
					_tmp9_ = string_replace (_tmp8_, "\"", "");
#line 95 "../libgitg/gitg-textconv.vala"
					_g_free0 (_tmp6_[i]);
#line 95 "../libgitg/gitg-textconv.vala"
					_tmp6_[i] = _tmp9_;
#line 1024 "gitg-textconv.c"
				}
			}
		}
#line 97 "../libgitg/gitg-textconv.vala"
		_tmp10_ = g_strdup ("/dev/stdin");
#line 97 "../libgitg/gitg-textconv.vala"
		_vala_array_add18 (&command_array, &command_array_length1, &_command_array_size_, _tmp10_);
#line 99 "../libgitg/gitg-textconv.vala"
		_tmp11_ = command_array;
#line 99 "../libgitg/gitg-textconv.vala"
		_tmp11__length1 = command_array_length1;
#line 99 "../libgitg/gitg-textconv.vala"
		_tmp12_ = g_subprocess_newv (_tmp11_, (G_SUBPROCESS_FLAGS_STDIN_PIPE | G_SUBPROCESS_FLAGS_STDOUT_PIPE) | G_SUBPROCESS_FLAGS_STDERR_PIPE, &_inner_error0_);
#line 99 "../libgitg/gitg-textconv.vala"
		subproc = _tmp12_;
#line 99 "../libgitg/gitg-textconv.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 99 "../libgitg/gitg-textconv.vala"
			command_array = (_vala_array_free (command_array, command_array_length1, (GDestroyNotify) g_free), NULL);
#line 1044 "gitg-textconv.c"
			goto __catch0_g_error;
		}
#line 101 "../libgitg/gitg-textconv.vala"
		_tmp13_ = (data != NULL) ? _vala_array_dup29 (data, data_length1) : data;
#line 101 "../libgitg/gitg-textconv.vala"
		_tmp13__length1 = data_length1;
#line 101 "../libgitg/gitg-textconv.vala"
		_tmp14_ = (GMemoryInputStream*) g_memory_input_stream_new_from_data (_tmp13_, _tmp13__length1, _g_free_gdestroy_notify);
#line 101 "../libgitg/gitg-textconv.vala"
		input = _tmp14_;
#line 102 "../libgitg/gitg-textconv.vala"
		_tmp15_ = subproc;
#line 102 "../libgitg/gitg-textconv.vala"
		_tmp16_ = g_subprocess_get_stdin_pipe (_tmp15_);
#line 102 "../libgitg/gitg-textconv.vala"
		_tmp17_ = input;
#line 102 "../libgitg/gitg-textconv.vala"
		g_output_stream_splice (_tmp16_, (GInputStream*) _tmp17_, G_OUTPUT_STREAM_SPLICE_CLOSE_TARGET, NULL, &_inner_error0_);
#line 102 "../libgitg/gitg-textconv.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 102 "../libgitg/gitg-textconv.vala"
			_g_object_unref0 (input);
#line 102 "../libgitg/gitg-textconv.vala"
			_g_object_unref0 (subproc);
#line 102 "../libgitg/gitg-textconv.vala"
			command_array = (_vala_array_free (command_array, command_array_length1, (GDestroyNotify) g_free), NULL);
#line 1071 "gitg-textconv.c"
			goto __catch0_g_error;
		}
#line 104 "../libgitg/gitg-textconv.vala"
		_tmp18_ = subproc;
#line 104 "../libgitg/gitg-textconv.vala"
		_tmp19_ = g_subprocess_get_stdout_pipe (_tmp18_);
#line 104 "../libgitg/gitg-textconv.vala"
		_tmp20_ = _g_object_ref0 (_tmp19_);
#line 104 "../libgitg/gitg-textconv.vala"
		end_pipe = _tmp20_;
#line 105 "../libgitg/gitg-textconv.vala"
		_tmp21_ = end_pipe;
#line 105 "../libgitg/gitg-textconv.vala"
		_tmp22_ = g_data_input_stream_new (_tmp21_);
#line 105 "../libgitg/gitg-textconv.vala"
		output = _tmp22_;
#line 106 "../libgitg/gitg-textconv.vala"
		line = NULL;
#line 1090 "gitg-textconv.c"
		{
			gboolean _tmp23_ = FALSE;
#line 107 "../libgitg/gitg-textconv.vala"
			_tmp23_ = TRUE;
#line 107 "../libgitg/gitg-textconv.vala"
			while (TRUE) {
#line 1097 "gitg-textconv.c"
				gchar* _tmp25_ = NULL;
				GDataInputStream* _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
				const gchar* _tmp29_;
#line 107 "../libgitg/gitg-textconv.vala"
				if (!_tmp23_) {
#line 1105 "gitg-textconv.c"
					const gchar* _tmp24_;
#line 112 "../libgitg/gitg-textconv.vala"
					_tmp24_ = line;
#line 112 "../libgitg/gitg-textconv.vala"
					if (!(_tmp24_ != NULL)) {
#line 112 "../libgitg/gitg-textconv.vala"
						break;
#line 1113 "gitg-textconv.c"
					}
				}
#line 107 "../libgitg/gitg-textconv.vala"
				_tmp23_ = FALSE;
#line 108 "../libgitg/gitg-textconv.vala"
				_tmp26_ = output;
#line 108 "../libgitg/gitg-textconv.vala"
				_tmp27_ = g_data_input_stream_read_line (_tmp26_, NULL, NULL, &_inner_error0_);
#line 108 "../libgitg/gitg-textconv.vala"
				_tmp25_ = _tmp27_;
#line 108 "../libgitg/gitg-textconv.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 108 "../libgitg/gitg-textconv.vala"
					_g_free0 (line);
#line 108 "../libgitg/gitg-textconv.vala"
					_g_object_unref0 (output);
#line 108 "../libgitg/gitg-textconv.vala"
					_g_object_unref0 (end_pipe);
#line 108 "../libgitg/gitg-textconv.vala"
					_g_object_unref0 (input);
#line 108 "../libgitg/gitg-textconv.vala"
					_g_object_unref0 (subproc);
#line 108 "../libgitg/gitg-textconv.vala"
					command_array = (_vala_array_free (command_array, command_array_length1, (GDestroyNotify) g_free), NULL);
#line 1138 "gitg-textconv.c"
					goto __catch0_g_error;
				}
#line 108 "../libgitg/gitg-textconv.vala"
				_tmp28_ = _tmp25_;
#line 108 "../libgitg/gitg-textconv.vala"
				_tmp25_ = NULL;
#line 108 "../libgitg/gitg-textconv.vala"
				_g_free0 (line);
#line 108 "../libgitg/gitg-textconv.vala"
				line = _tmp28_;
#line 109 "../libgitg/gitg-textconv.vala"
				_tmp29_ = line;
#line 109 "../libgitg/gitg-textconv.vala"
				if (_tmp29_ != NULL) {
#line 1153 "gitg-textconv.c"
					const gchar* _tmp30_;
					const gchar* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
					gchar* _tmp34_;
#line 110 "../libgitg/gitg-textconv.vala"
					_tmp30_ = lines;
#line 110 "../libgitg/gitg-textconv.vala"
					_tmp31_ = line;
#line 110 "../libgitg/gitg-textconv.vala"
					_tmp32_ = g_strconcat (_tmp31_, "\n", NULL);
#line 110 "../libgitg/gitg-textconv.vala"
					_tmp33_ = _tmp32_;
#line 110 "../libgitg/gitg-textconv.vala"
					_tmp34_ = g_strconcat (_tmp30_, _tmp33_, NULL);
#line 110 "../libgitg/gitg-textconv.vala"
					_g_free0 (lines);
#line 110 "../libgitg/gitg-textconv.vala"
					lines = _tmp34_;
#line 110 "../libgitg/gitg-textconv.vala"
					_g_free0 (_tmp33_);
#line 1175 "gitg-textconv.c"
				}
#line 107 "../libgitg/gitg-textconv.vala"
				_g_free0 (_tmp25_);
#line 1179 "gitg-textconv.c"
			}
		}
#line 114 "../libgitg/gitg-textconv.vala"
		_tmp35_ = subproc;
#line 114 "../libgitg/gitg-textconv.vala"
		_tmp36_ = g_subprocess_get_stderr_pipe (_tmp35_);
#line 114 "../libgitg/gitg-textconv.vala"
		_tmp37_ = _g_object_ref0 (_tmp36_);
#line 114 "../libgitg/gitg-textconv.vala"
		err_pipe = _tmp37_;
#line 115 "../libgitg/gitg-textconv.vala"
		_tmp38_ = err_pipe;
#line 115 "../libgitg/gitg-textconv.vala"
		_tmp39_ = g_data_input_stream_new (_tmp38_);
#line 115 "../libgitg/gitg-textconv.vala"
		err = _tmp39_;
#line 116 "../libgitg/gitg-textconv.vala"
		lineerr = NULL;
#line 1198 "gitg-textconv.c"
		{
			gboolean _tmp40_ = FALSE;
#line 117 "../libgitg/gitg-textconv.vala"
			_tmp40_ = TRUE;
#line 117 "../libgitg/gitg-textconv.vala"
			while (TRUE) {
#line 1205 "gitg-textconv.c"
				gchar* _tmp42_ = NULL;
				GDataInputStream* _tmp43_;
				gchar* _tmp44_;
				gchar* _tmp45_;
				const gchar* _tmp46_;
#line 117 "../libgitg/gitg-textconv.vala"
				if (!_tmp40_) {
#line 1213 "gitg-textconv.c"
					const gchar* _tmp41_;
#line 122 "../libgitg/gitg-textconv.vala"
					_tmp41_ = lineerr;
#line 122 "../libgitg/gitg-textconv.vala"
					if (!(_tmp41_ != NULL)) {
#line 122 "../libgitg/gitg-textconv.vala"
						break;
#line 1221 "gitg-textconv.c"
					}
				}
#line 117 "../libgitg/gitg-textconv.vala"
				_tmp40_ = FALSE;
#line 118 "../libgitg/gitg-textconv.vala"
				_tmp43_ = err;
#line 118 "../libgitg/gitg-textconv.vala"
				_tmp44_ = g_data_input_stream_read_line (_tmp43_, NULL, NULL, &_inner_error0_);
#line 118 "../libgitg/gitg-textconv.vala"
				_tmp42_ = _tmp44_;
#line 118 "../libgitg/gitg-textconv.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 118 "../libgitg/gitg-textconv.vala"
					_g_free0 (lineerr);
#line 118 "../libgitg/gitg-textconv.vala"
					_g_object_unref0 (err);
#line 118 "../libgitg/gitg-textconv.vala"
					_g_object_unref0 (err_pipe);
#line 118 "../libgitg/gitg-textconv.vala"
					_g_free0 (line);
#line 118 "../libgitg/gitg-textconv.vala"
					_g_object_unref0 (output);
#line 118 "../libgitg/gitg-textconv.vala"
					_g_object_unref0 (end_pipe);
#line 118 "../libgitg/gitg-textconv.vala"
					_g_object_unref0 (input);
#line 118 "../libgitg/gitg-textconv.vala"
					_g_object_unref0 (subproc);
#line 118 "../libgitg/gitg-textconv.vala"
					command_array = (_vala_array_free (command_array, command_array_length1, (GDestroyNotify) g_free), NULL);
#line 1252 "gitg-textconv.c"
					goto __catch0_g_error;
				}
#line 118 "../libgitg/gitg-textconv.vala"
				_tmp45_ = _tmp42_;
#line 118 "../libgitg/gitg-textconv.vala"
				_tmp42_ = NULL;
#line 118 "../libgitg/gitg-textconv.vala"
				_g_free0 (lineerr);
#line 118 "../libgitg/gitg-textconv.vala"
				lineerr = _tmp45_;
#line 119 "../libgitg/gitg-textconv.vala"
				_tmp46_ = lineerr;
#line 119 "../libgitg/gitg-textconv.vala"
				if (_tmp46_ != NULL) {
#line 1267 "gitg-textconv.c"
					FILE* _tmp47_;
					const gchar* _tmp48_;
#line 120 "../libgitg/gitg-textconv.vala"
					_tmp47_ = stderr;
#line 120 "../libgitg/gitg-textconv.vala"
					_tmp48_ = lineerr;
#line 120 "../libgitg/gitg-textconv.vala"
					fprintf (_tmp47_, ": %s\n", _tmp48_);
#line 1276 "gitg-textconv.c"
				}
#line 117 "../libgitg/gitg-textconv.vala"
				_g_free0 (_tmp42_);
#line 1280 "gitg-textconv.c"
			}
		}
#line 91 "../libgitg/gitg-textconv.vala"
		_g_free0 (lineerr);
#line 91 "../libgitg/gitg-textconv.vala"
		_g_object_unref0 (err);
#line 91 "../libgitg/gitg-textconv.vala"
		_g_object_unref0 (err_pipe);
#line 91 "../libgitg/gitg-textconv.vala"
		_g_free0 (line);
#line 91 "../libgitg/gitg-textconv.vala"
		_g_object_unref0 (output);
#line 91 "../libgitg/gitg-textconv.vala"
		_g_object_unref0 (end_pipe);
#line 91 "../libgitg/gitg-textconv.vala"
		_g_object_unref0 (input);
#line 91 "../libgitg/gitg-textconv.vala"
		_g_object_unref0 (subproc);
#line 91 "../libgitg/gitg-textconv.vala"
		command_array = (_vala_array_free (command_array, command_array_length1, (GDestroyNotify) g_free), NULL);
#line 1301 "gitg-textconv.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp49_;
		GError* _tmp50_;
		const gchar* _tmp51_;
#line 91 "../libgitg/gitg-textconv.vala"
		e = _inner_error0_;
#line 91 "../libgitg/gitg-textconv.vala"
		_inner_error0_ = NULL;
#line 124 "../libgitg/gitg-textconv.vala"
		_tmp49_ = stderr;
#line 124 "../libgitg/gitg-textconv.vala"
		_tmp50_ = e;
#line 124 "../libgitg/gitg-textconv.vala"
		_tmp51_ = _tmp50_->message;
#line 124 "../libgitg/gitg-textconv.vala"
		fprintf (_tmp49_, "Failed to apply texconv: %s\n", _tmp51_);
#line 91 "../libgitg/gitg-textconv.vala"
		_g_error_free0 (e);
#line 1324 "gitg-textconv.c"
	}
	__finally0:
#line 91 "../libgitg/gitg-textconv.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 91 "../libgitg/gitg-textconv.vala"
		_g_free0 (lines);
#line 91 "../libgitg/gitg-textconv.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 91 "../libgitg/gitg-textconv.vala"
		g_clear_error (&_inner_error0_);
#line 91 "../libgitg/gitg-textconv.vala"
		return NULL;
#line 1337 "gitg-textconv.c"
	}
#line 126 "../libgitg/gitg-textconv.vala"
	_tmp52_ = lines;
#line 126 "../libgitg/gitg-textconv.vala"
	_tmp53_ = string_get_data (_tmp52_, &_tmp54_);
#line 126 "../libgitg/gitg-textconv.vala"
	_tmp53__length1 = _tmp54_;
#line 126 "../libgitg/gitg-textconv.vala"
	_tmp55_ = _tmp53_;
#line 126 "../libgitg/gitg-textconv.vala"
	_tmp55__length1 = _tmp53__length1;
#line 126 "../libgitg/gitg-textconv.vala"
	_tmp56_ = (_tmp55_ != NULL) ? _vala_array_dup30 (_tmp55_, _tmp55__length1) : _tmp55_;
#line 126 "../libgitg/gitg-textconv.vala"
	_tmp56__length1 = _tmp55__length1;
#line 126 "../libgitg/gitg-textconv.vala"
	_tmp57_ = _tmp56_;
#line 126 "../libgitg/gitg-textconv.vala"
	_tmp57__length1 = _tmp56__length1;
#line 126 "../libgitg/gitg-textconv.vala"
	if (result_length1) {
#line 126 "../libgitg/gitg-textconv.vala"
		*result_length1 = _tmp57__length1;
#line 1361 "gitg-textconv.c"
	}
#line 126 "../libgitg/gitg-textconv.vala"
	result = _tmp57_;
#line 126 "../libgitg/gitg-textconv.vala"
	_g_free0 (lines);
#line 126 "../libgitg/gitg-textconv.vala"
	return result;
#line 1369 "gitg-textconv.c"
}

GitgTextConv*
gitg_text_conv_construct (GType object_type)
{
	GitgTextConv* self = NULL;
#line 24 "../libgitg/gitg-textconv.vala"
	self = (GitgTextConv*) g_type_create_instance (object_type);
#line 24 "../libgitg/gitg-textconv.vala"
	return self;
#line 1380 "gitg-textconv.c"
}

GitgTextConv*
gitg_text_conv_new (void)
{
#line 24 "../libgitg/gitg-textconv.vala"
	return gitg_text_conv_construct (GITG_TYPE_TEXT_CONV);
#line 1388 "gitg-textconv.c"
}

static void
gitg_value_text_conv_init (GValue* value)
{
#line 24 "../libgitg/gitg-textconv.vala"
	value->data[0].v_pointer = NULL;
#line 1396 "gitg-textconv.c"
}

static void
gitg_value_text_conv_free_value (GValue* value)
{
#line 24 "../libgitg/gitg-textconv.vala"
	if (value->data[0].v_pointer) {
#line 24 "../libgitg/gitg-textconv.vala"
		gitg_text_conv_unref (value->data[0].v_pointer);
#line 1406 "gitg-textconv.c"
	}
}

static void
gitg_value_text_conv_copy_value (const GValue* src_value,
                                 GValue* dest_value)
{
#line 24 "../libgitg/gitg-textconv.vala"
	if (src_value->data[0].v_pointer) {
#line 24 "../libgitg/gitg-textconv.vala"
		dest_value->data[0].v_pointer = gitg_text_conv_ref (src_value->data[0].v_pointer);
#line 1418 "gitg-textconv.c"
	} else {
#line 24 "../libgitg/gitg-textconv.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1422 "gitg-textconv.c"
	}
}

static gpointer
gitg_value_text_conv_peek_pointer (const GValue* value)
{
#line 24 "../libgitg/gitg-textconv.vala"
	return value->data[0].v_pointer;
#line 1431 "gitg-textconv.c"
}

static gchar*
gitg_value_text_conv_collect_value (GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
#line 24 "../libgitg/gitg-textconv.vala"
	if (collect_values[0].v_pointer) {
#line 1442 "gitg-textconv.c"
		GitgTextConv * object;
		object = collect_values[0].v_pointer;
#line 24 "../libgitg/gitg-textconv.vala"
		if (object->parent_instance.g_class == NULL) {
#line 24 "../libgitg/gitg-textconv.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1449 "gitg-textconv.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 24 "../libgitg/gitg-textconv.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1453 "gitg-textconv.c"
		}
#line 24 "../libgitg/gitg-textconv.vala"
		value->data[0].v_pointer = gitg_text_conv_ref (object);
#line 1457 "gitg-textconv.c"
	} else {
#line 24 "../libgitg/gitg-textconv.vala"
		value->data[0].v_pointer = NULL;
#line 1461 "gitg-textconv.c"
	}
#line 24 "../libgitg/gitg-textconv.vala"
	return NULL;
#line 1465 "gitg-textconv.c"
}

static gchar*
gitg_value_text_conv_lcopy_value (const GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	GitgTextConv ** object_p;
	object_p = collect_values[0].v_pointer;
#line 24 "../libgitg/gitg-textconv.vala"
	if (!object_p) {
#line 24 "../libgitg/gitg-textconv.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1480 "gitg-textconv.c"
	}
#line 24 "../libgitg/gitg-textconv.vala"
	if (!value->data[0].v_pointer) {
#line 24 "../libgitg/gitg-textconv.vala"
		*object_p = NULL;
#line 1486 "gitg-textconv.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 24 "../libgitg/gitg-textconv.vala"
		*object_p = value->data[0].v_pointer;
#line 1490 "gitg-textconv.c"
	} else {
#line 24 "../libgitg/gitg-textconv.vala"
		*object_p = gitg_text_conv_ref (value->data[0].v_pointer);
#line 1494 "gitg-textconv.c"
	}
#line 24 "../libgitg/gitg-textconv.vala"
	return NULL;
#line 1498 "gitg-textconv.c"
}

GParamSpec*
gitg_param_spec_text_conv (const gchar* name,
                           const gchar* nick,
                           const gchar* blurb,
                           GType object_type,
                           GParamFlags flags)
{
	GitgParamSpecTextConv* spec;
#line 24 "../libgitg/gitg-textconv.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GITG_TYPE_TEXT_CONV), NULL);
#line 24 "../libgitg/gitg-textconv.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 24 "../libgitg/gitg-textconv.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 24 "../libgitg/gitg-textconv.vala"
	return G_PARAM_SPEC (spec);
#line 1517 "gitg-textconv.c"
}

gpointer
gitg_value_get_text_conv (const GValue* value)
{
#line 24 "../libgitg/gitg-textconv.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GITG_TYPE_TEXT_CONV), NULL);
#line 24 "../libgitg/gitg-textconv.vala"
	return value->data[0].v_pointer;
#line 1527 "gitg-textconv.c"
}

void
gitg_value_set_text_conv (GValue* value,
                          gpointer v_object)
{
	GitgTextConv * old;
#line 24 "../libgitg/gitg-textconv.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GITG_TYPE_TEXT_CONV));
#line 24 "../libgitg/gitg-textconv.vala"
	old = value->data[0].v_pointer;
#line 24 "../libgitg/gitg-textconv.vala"
	if (v_object) {
#line 24 "../libgitg/gitg-textconv.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GITG_TYPE_TEXT_CONV));
#line 24 "../libgitg/gitg-textconv.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "../libgitg/gitg-textconv.vala"
		value->data[0].v_pointer = v_object;
#line 24 "../libgitg/gitg-textconv.vala"
		gitg_text_conv_ref (value->data[0].v_pointer);
#line 1549 "gitg-textconv.c"
	} else {
#line 24 "../libgitg/gitg-textconv.vala"
		value->data[0].v_pointer = NULL;
#line 1553 "gitg-textconv.c"
	}
#line 24 "../libgitg/gitg-textconv.vala"
	if (old) {
#line 24 "../libgitg/gitg-textconv.vala"
		gitg_text_conv_unref (old);
#line 1559 "gitg-textconv.c"
	}
}

void
gitg_value_take_text_conv (GValue* value,
                           gpointer v_object)
{
	GitgTextConv * old;
#line 24 "../libgitg/gitg-textconv.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GITG_TYPE_TEXT_CONV));
#line 24 "../libgitg/gitg-textconv.vala"
	old = value->data[0].v_pointer;
#line 24 "../libgitg/gitg-textconv.vala"
	if (v_object) {
#line 24 "../libgitg/gitg-textconv.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GITG_TYPE_TEXT_CONV));
#line 24 "../libgitg/gitg-textconv.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "../libgitg/gitg-textconv.vala"
		value->data[0].v_pointer = v_object;
#line 1580 "gitg-textconv.c"
	} else {
#line 24 "../libgitg/gitg-textconv.vala"
		value->data[0].v_pointer = NULL;
#line 1584 "gitg-textconv.c"
	}
#line 24 "../libgitg/gitg-textconv.vala"
	if (old) {
#line 24 "../libgitg/gitg-textconv.vala"
		gitg_text_conv_unref (old);
#line 1590 "gitg-textconv.c"
	}
}

static void
gitg_text_conv_class_init (GitgTextConvClass * klass,
                           gpointer klass_data)
{
#line 24 "../libgitg/gitg-textconv.vala"
	gitg_text_conv_parent_class = g_type_class_peek_parent (klass);
#line 24 "../libgitg/gitg-textconv.vala"
	((GitgTextConvClass *) klass)->finalize = gitg_text_conv_finalize;
#line 1602 "gitg-textconv.c"
}

static void
gitg_text_conv_instance_init (GitgTextConv * self,
                              gpointer klass)
{
#line 24 "../libgitg/gitg-textconv.vala"
	self->ref_count = 1;
#line 1611 "gitg-textconv.c"
}

static void
gitg_text_conv_finalize (GitgTextConv * obj)
{
	GitgTextConv * self;
#line 24 "../libgitg/gitg-textconv.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GITG_TYPE_TEXT_CONV, GitgTextConv);
#line 24 "../libgitg/gitg-textconv.vala"
	g_signal_handlers_destroy (self);
#line 1622 "gitg-textconv.c"
}

 G_GNUC_NO_INLINE static GType
gitg_text_conv_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { gitg_value_text_conv_init, gitg_value_text_conv_free_value, gitg_value_text_conv_copy_value, gitg_value_text_conv_peek_pointer, "p", gitg_value_text_conv_collect_value, "p", gitg_value_text_conv_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GitgTextConvClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gitg_text_conv_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GitgTextConv), 0, (GInstanceInitFunc) gitg_text_conv_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType gitg_text_conv_type_id;
	gitg_text_conv_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GitgTextConv", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return gitg_text_conv_type_id;
}

GType
gitg_text_conv_get_type (void)
{
	static gsize gitg_text_conv_type_id__once = 0;
	if (g_once_init_enter (&gitg_text_conv_type_id__once)) {
		GType gitg_text_conv_type_id;
		gitg_text_conv_type_id = gitg_text_conv_get_type_once ();
		g_once_init_leave (&gitg_text_conv_type_id__once, gitg_text_conv_type_id);
	}
	return gitg_text_conv_type_id__once;
}

gpointer
gitg_text_conv_ref (gpointer instance)
{
	GitgTextConv * self;
	self = instance;
#line 24 "../libgitg/gitg-textconv.vala"
	g_atomic_int_inc (&self->ref_count);
#line 24 "../libgitg/gitg-textconv.vala"
	return instance;
#line 1657 "gitg-textconv.c"
}

void
gitg_text_conv_unref (gpointer instance)
{
	GitgTextConv * self;
	self = instance;
#line 24 "../libgitg/gitg-textconv.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 24 "../libgitg/gitg-textconv.vala"
		GITG_TEXT_CONV_GET_CLASS (self)->finalize (self);
#line 24 "../libgitg/gitg-textconv.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1671 "gitg-textconv.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

